import { useEffect } from 'react';

var usePassiveHandler = function usePassiveHandler() {
  return useEffect(function () {
    var cancelTouchmove = function cancelTouchmove(event) {
      return event.preventDefault();
    };

    document.body.addEventListener('touchmove', cancelTouchmove, {
      passive: false
    });
    return function () {
      document.body.removeEventListener('touchmove', cancelTouchmove);
    };
  }, []);
};

export default usePassiveHandler;