import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["observer", "eventOptions"];
import React, { useState, useEffect } from 'react';
import { hasIntersectionObserver, modeType } from './utils';
import LazyloadEvent from './LazyloadEvent';
import LazyLoadObserve from './LazyloadObserve';

var Lazyload = function Lazyload(props) {
  var _useState = useState('observer'),
      _useState2 = _slicedToArray(_useState, 2),
      mode = _useState2[0],
      setMode = _useState2[1];

  var observer = props.observer,
      eventOptions = props.eventOptions,
      resetProps = _objectWithoutProperties(props, _excluded);

  useEffect(function () {
    var toSetMode = function toSetMode(value) {
      if (!hasIntersectionObserver && value === modeType.observer) {
        value = modeType.event;
      }

      setMode(value);
    };

    toSetMode(observer ? modeType.observer : modeType.event);
  }, [observer]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, mode === modeType.event ? /*#__PURE__*/React.createElement(LazyloadEvent, _extends({}, resetProps, eventOptions)) : /*#__PURE__*/React.createElement(LazyLoadObserve, resetProps));
};

Lazyload.defaultProps = {
  loading: null,
  height: 0,
  observer: true
};
export default Lazyload;