import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["observer"];
import React, { useState, useEffect } from 'react';
import LazyloadImageEvent from './LazyloadImageEvent';
import LazyLoadImageObserve from './LazyloadImageObserve';
import { DEFAULT_EVENTS, hasIntersectionObserver, modeType } from './utils';

var Lazyload = function Lazyload(props) {
  var _useState = useState('observer'),
      _useState2 = _slicedToArray(_useState, 2),
      mode = _useState2[0],
      setMode = _useState2[1];

  var observer = props.observer,
      resetProps = _objectWithoutProperties(props, _excluded);

  useEffect(function () {
    var toSetMode = function toSetMode(value) {
      if (!hasIntersectionObserver && value === modeType.observer) {
        value = modeType.event;
      }

      setMode(value);
    };

    toSetMode(observer ? modeType.observer : modeType.event);
  }, [observer]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, mode === modeType.event ? /*#__PURE__*/React.createElement(LazyloadImageEvent, resetProps) : /*#__PURE__*/React.createElement(LazyLoadImageObserve, resetProps));
};

Lazyload.defaultProps = {
  loading: null,
  observer: true,
  eventOptions: {
    scrollContainer: document.body,
    offset: 0,
    debounce: 300,
    throttle: 0,
    listenEvents: DEFAULT_EVENTS
  }
};
export default Lazyload;