import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { useCallback, useEffect, useState } from 'react';

var useIntersectionObserver = function useIntersectionObserver(observerOptions, handleIntersection) {
  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      element = _useState2[0],
      setElement = _useState2[1];

  var handleElement = useCallback(function (node) {
    setElement(node);
  }, []);
  useEffect(function () {
    if (!element) return;
    var observer = new IntersectionObserver(handleIntersection, observerOptions);
    observer.observe(element); // eslint-disable-next-line consistent-return

    return function () {
      return observer && observer.disconnect && observer.disconnect();
    };
  }, [handleIntersection, observerOptions, element]);
  return handleElement;
};

export default useIntersectionObserver;