import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";

var genBasicKeys = function genBasicKeys(props) {
  var keys = Array(9).fill('').map(function (_, i) {
    return {
      text: i + 1
    };
  });

  if (props.randomKeyOrder) {
    keys.sort(function () {
      return Math.random() > 0.5 ? 1 : -1;
    });
  }

  return keys;
};

export var genDefaultKeys = function genDefaultKeys(props) {
  return [].concat(_toConsumableArray(genBasicKeys(props)), [{
    text: props.extraKey,
    type: 'extra'
  }, {
    text: 0
  }, {
    text: props.showDeleteKey ? props.deleteButtonText : '',
    type: props.showDeleteKey ? 'delete' : ''
  }]);
};
export var genCustomKeys = function genCustomKeys(props) {
  var keys = genBasicKeys(props);
  var extraKey = props.extraKey;
  var extraKeys = Array.isArray(extraKey) ? extraKey : [extraKey];

  if (extraKeys.length === 1) {
    keys.push({
      text: 0,
      wider: true
    }, {
      text: extraKeys[0],
      type: 'extra'
    });
  } else if (extraKeys.length === 2) {
    keys.push({
      text: extraKeys[0],
      type: 'extra'
    }, {
      text: 0
    }, {
      text: extraKeys[1],
      type: 'extra'
    });
  }

  return keys;
};