import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import React, { useContext, useRef } from 'react';
import { CSSTransition } from 'react-transition-group';
import classnames from 'classnames';
import { useLockScroll } from '../hooks/use-lock-scroll';
import { isDef } from '../utils';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';

var Overlay = function Overlay(props) {
  var _useContext = useContext(ConfigProviderContext),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('overlay', prefixCls),
      _createNamespace2 = _slicedToArray(_createNamespace, 1),
      bem = _createNamespace2[0];

  var nodeRef = useRef(null);
  useLockScroll(nodeRef, props.visible && props.lockScroll);
  var visible = props.visible,
      duration = props.duration,
      customStyle = props.customStyle,
      children = props.children;

  var renderOverlay = function renderOverlay() {
    var style = _objectSpread(_objectSpread({
      zIndex: props.zIndex !== undefined ? +props.zIndex : undefined
    }, props.style), customStyle);

    if (isDef(duration)) {
      style.animationDuration = "".concat(duration, "ms");
    }

    return /*#__PURE__*/React.createElement("div", {
      ref: nodeRef,
      style: style,
      onClick: props.onClick,
      className: classnames(bem(), props.className)
    }, children);
  };

  return /*#__PURE__*/React.createElement(CSSTransition, {
    nodeRef: nodeRef,
    mountOnEnter: true,
    unmountOnExit: true,
    in: visible,
    timeout: duration,
    classNames: "rc-fade"
  }, renderOverlay());
};

Overlay.defaultProps = {
  lockScroll: true,
  duration: 300
};
export default Overlay;