"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CalendarDay = function CalendarDay(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('calendar', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var item = props.item,
      index = props.index,
      color = props.color,
      offset = props.offset,
      rowHeight = props.rowHeight;
  var calcStyle = (0, _react().useMemo)(function () {
    var style = {
      height: rowHeight
    };

    if (item.type === 'placeholder') {
      style.width = '100%';
      return style;
    }

    if (index === 0) {
      style.marginLeft = "".concat(100 * offset / 7, "%");
    }

    if (color) {
      switch (item.type) {
        case 'end':
        case 'start':
        case 'start-end':
        case 'multiple-middle':
        case 'multiple-selected':
          style.background = color;
          break;

        case 'middle':
          style.color = color;
          break;

        default:
          break;
      }
    }

    return style;
  }, [item, index, color, offset, rowHeight]);

  var onClick = function onClick() {
    if (props.item.type !== 'disabled') {
      var _props$onClick;

      (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, item);
    }
  };

  var renderTopInfo = function renderTopInfo() {
    var topInfo = props.item.topInfo;
    return topInfo || props.topInfoRender ? /*#__PURE__*/_react().default.createElement("div", {
      key: String(index),
      className: (0, _classnames().default)(bem('top-info'))
    }, props.topInfoRender ? props.topInfoRender(props.item) : topInfo) : null;
  };

  var renderBottomInfo = function renderBottomInfo() {
    var bottomInfo = props.item.bottomInfo;
    return bottomInfo || props.bottomInfoRender ? /*#__PURE__*/_react().default.createElement("div", {
      key: String(index),
      className: (0, _classnames().default)(bem('bottom-info'))
    }, props.bottomInfoRender ? props.bottomInfoRender(props.item) : bottomInfo) : null;
  };

  var renderContent = function renderContent() {
    var type = item.type,
        text = item.text;
    var Nodes = [renderTopInfo(), text, renderBottomInfo()];

    if (type === 'selected') {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('selected-day')),
        style: {
          width: rowHeight,
          height: rowHeight,
          background: color
        }
      }, Nodes);
    }

    return Nodes;
  };

  var _props$item = props.item,
      type = _props$item.type,
      className = _props$item.className;
  return type === 'placeholder' ? /*#__PURE__*/_react().default.createElement("div", {
    key: String(index),
    className: (0, _classnames().default)(bem('day')),
    style: calcStyle
  }) : /*#__PURE__*/_react().default.createElement("div", {
    role: "gridcell",
    style: calcStyle,
    className: (0, _classnames().default)(bem('day', type), className),
    tabIndex: type === 'disabled' ? undefined : -1,
    onClick: onClick
  }, renderContent());
};

CalendarDay.defaultProps = {
  offset: 0
};
var _default = CalendarDay;
exports.default = _default;