"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _toConsumableArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

  _toConsumableArray2 = function _toConsumableArray2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CalendarHeader = function CalendarHeader(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('calendar', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var onClickSubtitle = props.onClickSubtitle,
      showTitle = props.showTitle,
      showSubtitle = props.showSubtitle,
      firstDayOfWeek = props.firstDayOfWeek;

  var renderTitle = function renderTitle() {
    var title = props.title;
    return showTitle ? /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('header-title'))
    }, title) : null;
  };

  var renderSubtitle = function renderSubtitle() {
    var title = props.subtitle;
    return showSubtitle ? /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('header-subtitle')),
      onClick: onClickSubtitle
    }, title) : null;
  };

  var renderWeekDays = function renderWeekDays() {
    var weekdays = ['日', '一', '二', '三', '四', '五', '六'];
    var renderWeekDaysArr = [].concat((0, _toConsumableArray2().default)(weekdays.slice(firstDayOfWeek, 7)), (0, _toConsumableArray2().default)(weekdays.slice(0, firstDayOfWeek)));
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('weekdays'))
    }, renderWeekDaysArr.map(function (text, index) {
      return /*#__PURE__*/_react().default.createElement("span", {
        key: index,
        className: (0, _classnames().default)(bem('weekday'))
      }, text);
    }));
  };

  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('header'))
  }, renderTitle(), renderSubtitle(), renderWeekDays());
};

var _default = CalendarHeader;
exports.default = _default;