"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _CalendarDay = _interopRequireDefault(require("./CalendarDay"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _utils = require("./utils");

var _utils2 = require("../utils");

var _getRect = require("../hooks/get-rect");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* eslint-disable @typescript-eslint/no-shadow */
var CalendarMonth = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('calendar', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useState = (0, _react().useState)(false),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var showMonthTitle = props.showMonthTitle,
      date = props.date,
      showMark = props.showMark,
      firstDayOfWeek = props.firstDayOfWeek;
  var daysRef = (0, _react().useRef)(null);

  var _useState3 = (0, _react().useState)(),
      _useState4 = (0, _slicedToArray2().default)(_useState3, 2),
      monthRef = _useState4[0],
      setMonthRef = _useState4[1];

  var height = (0, _react().useRef)(0);
  (0, _react().useEffect)(function () {
    if (monthRef) {
      height.current = (0, _getRect.getRect)(monthRef).height;
    }
  }, [monthRef]);
  var title = (0, _react().useMemo)(function () {
    var formatterFn = props.formatMonthTitle || _utils.formatMonthTitle;
    return formatterFn(date);
  }, [date]);
  var rowHeight = (0, _react().useMemo)(function () {
    return (0, _utils2.addUnit)(props.rowHeight);
  }, [props.rowHeight]);
  var offset = (0, _react().useMemo)(function () {
    var realDay = date.getDay();

    if (firstDayOfWeek) {
      return (realDay + 7 - firstDayOfWeek) % 7;
    }

    return realDay;
  }, [date, firstDayOfWeek]);
  var totalDay = (0, _react().useMemo)(function () {
    return (0, _utils.getMonthEndDay)(date.getFullYear(), date.getMonth() + 1);
  }, [date]);
  var shouldRender = (0, _react().useMemo)(function () {
    return visible || !props.lazyRender;
  }, [visible, props.lazyRender]);

  var getTitle = function getTitle() {
    return title;
  };

  var onClick = function onClick(item) {
    var _props$onClick;

    (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, item);
  };

  var getMultipleDayType = function getMultipleDayType(day) {
    var isSelected = function isSelected(date) {
      return props.currentDate.some(function (item) {
        return (0, _utils.compareDay)(item, date) === 0;
      });
    };

    if (isSelected(day)) {
      var prevDay = (0, _utils.getPrevDay)(day);
      var nextDay = (0, _utils.getNextDay)(day);
      var prevSelected = isSelected(prevDay);
      var nextSelected = isSelected(nextDay);

      if (prevSelected && nextSelected) {
        return 'multiple-middle';
      }

      if (prevSelected) {
        return 'end';
      }

      if (nextSelected) {
        return 'start';
      }

      return 'multiple-selected';
    }

    return '';
  };

  var getRangeDayType = function getRangeDayType(day) {
    var _ref = props.currentDate,
        _ref2 = (0, _slicedToArray2().default)(_ref, 2),
        startDay = _ref2[0],
        endDay = _ref2[1];

    if (!startDay) {
      return '';
    }

    var compareToStart = (0, _utils.compareDay)(day, startDay);

    if (!endDay) {
      return compareToStart === 0 ? 'start' : '';
    }

    var compareToEnd = (0, _utils.compareDay)(day, endDay);

    if (props.allowSameDay && compareToStart === 0 && compareToEnd === 0) {
      return 'start-end';
    }

    if (compareToStart === 0) {
      return 'start';
    }

    if (compareToEnd === 0) {
      return 'end';
    }

    if (compareToStart > 0 && compareToEnd < 0) {
      return 'middle';
    }

    return '';
  };

  var getDayType = function getDayType(day) {
    var type = props.type,
        minDate = props.minDate,
        maxDate = props.maxDate,
        currentDate = props.currentDate;

    if ((0, _utils.compareDay)(day, minDate) < 0 || (0, _utils.compareDay)(day, maxDate) > 0) {
      return 'disabled';
    }

    if (Array.isArray(currentDate)) {
      if (type === 'multiple') {
        return getMultipleDayType(day);
      }

      if (type === 'range') {
        return getRangeDayType(day);
      }
    } else if (type === 'single') {
      return (0, _utils.compareDay)(day, currentDate) === 0 ? 'selected' : '';
    }

    return '';
  };

  var getBottomInfo = function getBottomInfo(dayType) {
    if (props.type === 'range') {
      if (dayType === 'start' || dayType === 'end') {
        return (0, _utils.t)(dayType);
      }

      if (dayType === 'start-end') {
        return (0, _utils.t)('startEnd');
      }
    }

    return '';
  };

  var renderTitle = function renderTitle() {
    return showMonthTitle ? /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('month-title'))
    }, title) : null;
  };

  var renderMark = function renderMark() {
    return showMark && shouldRender ? /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('month-mark'))
    }, props.date.getMonth() + 1) : null;
  };

  var placeholders = (0, _react().useMemo)(function () {
    var count = Math.ceil((totalDay + offset) / 7);
    return Array(count).fill({
      type: 'placeholder'
    });
  }, [totalDay, offset]);
  var daysList = (0, _react().useMemo)(function () {
    var days = [];
    var year = props.date.getFullYear();
    var month = props.date.getMonth();

    for (var day = 1; day <= totalDay; day++) {
      var _date = new Date(year, month, day);

      var type = getDayType(_date);
      var config = {
        date: _date,
        type: type,
        text: day,
        bottomInfo: getBottomInfo(type)
      };

      if (props.formatter) {
        config = props.formatter(config);
      }

      days.push(config);
    }

    return days;
  }, [props.currentDate, props.date, props.formatter]);
  var disabledDays = (0, _react().useMemo)(function () {
    return daysList.filter(function (day) {
      return day.type === 'disabled';
    });
  }, [daysList]);

  var scrollToDate = function scrollToDate(body, targetDate) {
    if (daysRef.current) {
      var daysRect = (0, _getRect.getRect)(daysRef.current);
      var totalRows = placeholders.length;
      var currentRow = Math.ceil((targetDate.getDate() + offset) / 7);
      var rowOffset = (currentRow - 1) * daysRect.height / totalRows;
      (0, _utils2.setScrollTop)(body, daysRect.top + rowOffset + body.scrollTop - (0, _getRect.getRect)(body).top);
    }
  };

  var renderDay = function renderDay(item, index) {
    return /*#__PURE__*/_react().default.createElement(_CalendarDay.default, {
      key: String(index),
      item: item,
      index: index,
      color: props.color,
      offset: offset,
      rowHeight: rowHeight,
      onClick: onClick
    });
  };

  var renderDays = function renderDays() {
    return /*#__PURE__*/_react().default.createElement("div", {
      ref: daysRef,
      role: "grid",
      className: (0, _classnames().default)(bem('days'))
    }, renderMark(), (shouldRender ? daysList : placeholders).map(renderDay));
  };

  (0, _react().useImperativeHandle)(ref, function () {
    return {
      getTitle: getTitle,
      getHeight: function getHeight() {
        return height.current;
      },
      setVisible: setVisible,
      scrollToDate: scrollToDate,
      disabledDays: disabledDays
    };
  });
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('month')),
    ref: setMonthRef
  }, renderTitle(), renderDays());
});
CalendarMonth.defaultProps = {};
var _default = CalendarMonth;
exports.default = _default;