"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

var _ = require("..");

var _utils = require("../utils");

var _utils2 = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TimePicker = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var formatValue = function formatValue(value) {
    var minHour = props.minHour,
        maxHour = props.maxHour,
        minMinute = props.minMinute,
        maxMinute = props.maxMinute;

    if (!value) {
      value = "".concat((0, _utils.padZero)(minHour), ":").concat((0, _utils.padZero)(minHour));
    }

    var _value$split = value.split(':'),
        _value$split2 = (0, _slicedToArray2().default)(_value$split, 2),
        hour = _value$split2[0],
        minute = _value$split2[1];

    hour = (0, _utils.padZero)((0, _utils.range)(+hour, +minHour, +maxHour));
    minute = (0, _utils.padZero)((0, _utils.range)(+minute, +minMinute, +maxMinute));
    return "".concat(hour, ":").concat(minute);
  };

  var picker = (0, _react().useRef)(null);

  var _useState = (0, _react().useState)(formatValue(props.value)),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      currentDate = _useState2[0],
      setCurrentDate = _useState2[1];

  var currentDateRef = (0, _react().useRef)(null);
  currentDateRef.current = currentDate;
  var ranges = (0, _react().useMemo)(function () {
    return [{
      type: 'hour',
      range: [+props.minHour, +props.maxHour]
    }, {
      type: 'minute',
      range: [+props.minMinute, +props.maxMinute]
    }];
  }, [props.minHour, props.maxHour, props.minMinute, props.maxMinute]);
  var originColumns = (0, _react().useMemo)(function () {
    return ranges.map(function (_ref) {
      var type = _ref.type,
          rangeArr = _ref.range;
      var values = (0, _utils2.times)(rangeArr[1] - rangeArr[0] + 1, function (index) {
        return (0, _utils.padZero)(rangeArr[0] + index);
      });

      if (props.filter) {
        values = props.filter(type, values);
      }

      return {
        type: type,
        values: values
      };
    });
  }, [ranges, props.filter]);
  var columns = (0, _react().useMemo)(function () {
    return originColumns.map(function (column) {
      return {
        values: column.values.map(function (value) {
          return props.formatter(column.type, value);
        })
      };
    });
  }, [originColumns]);

  var updateColumnValue = function updateColumnValue(date) {
    var pair = date ? date.split(':') : currentDate.split(':');
    var values = [props.formatter('hour', pair[0]), props.formatter('minute', pair[1])];
    setTimeout(function () {
      var _picker$current;

      (_picker$current = picker.current) === null || _picker$current === void 0 ? void 0 : _picker$current.setValues(values);
    }, 0);
  };

  var updateInnerValue = function updateInnerValue() {
    var _picker$current$getIn = picker.current.getIndexes(),
        _picker$current$getIn2 = (0, _slicedToArray2().default)(_picker$current$getIn, 2),
        hourIndex = _picker$current$getIn2[0],
        minuteIndex = _picker$current$getIn2[1];

    var _originColumns = (0, _slicedToArray2().default)(originColumns, 2),
        hourColumn = _originColumns[0],
        minuteColumn = _originColumns[1];

    var hour = hourColumn.values[hourIndex] || hourColumn.values[0];
    var minute = minuteColumn.values[minuteIndex] || minuteColumn.values[0];
    setCurrentDate(formatValue("".concat(hour, ":").concat(minute)));
    updateColumnValue(formatValue("".concat(hour, ":").concat(minute)));
  };

  var onConfirm = function onConfirm() {
    var _props$onConfirm;

    return (_props$onConfirm = props.onConfirm) === null || _props$onConfirm === void 0 ? void 0 : _props$onConfirm.call(props, currentDate);
  };

  var onCancel = function onCancel() {
    return props.onCancel();
  };

  var onChange = function onChange(value) {
    updateInnerValue();
    setTimeout(function () {
      var _props$onChange;

      (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, currentDateRef);
    }, 0);
  };

  (0, _react().useEffect)(function () {
    updateColumnValue();
  }, [columns]);
  (0, _.useUpdateEffect)(function () {
    updateInnerValue();
  }, [props.filter, props.maxHour, props.minMinute, props.maxMinute]);
  (0, _.useUpdateEffect)(function () {
    setTimeout(updateInnerValue, 0);
  }, [props.minHour]);
  (0, _.useUpdateEffect)(function () {
    var value = formatValue(props.value);

    if (value !== currentDate) {
      setCurrentDate(value);
      updateColumnValue(value);
    }
  }, [props.value]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      getPicker: function getPicker() {
        return picker.current;
      }
    };
  });
  return /*#__PURE__*/_react().default.createElement(_.Picker, {
    ref: picker,
    columns: columns,
    readonly: props.readonly,
    onChange: onChange,
    onCancel: onCancel,
    onConfirm: onConfirm
  });
});
TimePicker.defaultProps = {
  minHour: 0,
  maxHour: 23,
  minMinute: 0,
  maxMinute: 59,
  formatter: function formatter(type, value) {
    return value;
  }
};
var _default = TimePicker;
exports.default = _default;