"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DropdownMenuContext = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames2() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames2 = function _classnames2() {
    return data;
  };

  return data;
}

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _constant = require("../utils/constant");

var _utils = require("../utils");

var _useScrollParent = _interopRequireDefault(require("../hooks/use-scroll-parent"));

var _useClickAway = _interopRequireDefault(require("../hooks/use-click-away"));

var _useEventListener = _interopRequireDefault(require("../hooks/use-event-listener"));

var _useRefs3 = _interopRequireDefault(require("../hooks/use-refs"));

var _getRect = _interopRequireDefault(require("../hooks/get-rect"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var DropdownMenuContext = /*#__PURE__*/(0, _react().createContext)({});
exports.DropdownMenuContext = DropdownMenuContext;
var DropdownMenu = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('dropdown-menu', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useState = (0, _react().useState)(props.shouldRenderTitle),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      titleFlag = _useState2[0],
      setTitleFlag = _useState2[1];

  var _useState3 = (0, _react().useState)(null),
      _useState4 = (0, _slicedToArray2().default)(_useState3, 2),
      showPopupIndex = _useState4[0],
      setShowPopupIndex = _useState4[1];

  var showPopupIndexRef = (0, _react().useRef)(null);
  var rect = (0, _react().useRef)({
    bottom: 0,
    top: 0
  });
  var root = (0, _react().useRef)();
  var barRef = (0, _react().useRef)();
  var offsetRef = (0, _react().useRef)(0);

  var _useRefs = (0, _useRefs3.default)(),
      _useRefs2 = (0, _slicedToArray2().default)(_useRefs, 2),
      childrenRefs = _useRefs2[0],
      setChildrenRefs = _useRefs2[1];

  var scrollParent = (0, _useScrollParent.default)(root);
  var opened = (0, _react().useMemo)(function () {
    return showPopupIndex !== null;
  }, [showPopupIndex]);

  var barStyle = function barStyle() {
    if (opened && (0, _utils.isDef)(props.zIndex)) {
      return {
        zIndex: +props.zIndex + 1
      };
    }

    return {};
  };

  var updateShowPopupIndex = function updateShowPopupIndex(current) {
    showPopupIndexRef.current = current;
    setShowPopupIndex(current);
  };

  var updateOffset = function updateOffset() {
    if (barRef.current) {
      rect.current = (0, _getRect.default)(barRef.current);

      if (props.direction === 'down') {
        offsetRef.current = rect.current.bottom;
      } else {
        offsetRef.current = window.innerHeight - rect.current.top;
      }
    }
  };

  var closeAll = function closeAll() {
    childrenRefs.forEach(function (item) {
      item.toggle(false);
    });
    updateShowPopupIndex(null);
  };

  (0, _react().useImperativeHandle)(ref, function () {
    return {
      close: closeAll
    };
  });

  var onClickAway = function onClickAway() {
    if (props.closeOnClickOutside) {
      closeAll();
    }
  };

  (0, _react().useEffect)(function () {
    if (barRef.current) {
      updateOffset();
    }
  }, [barRef.current]);

  var onScroll = function onScroll() {
    if (opened) {
      updateOffset();
    }
  };

  var showItem = function showItem(index) {
    var item = childrenRefs[index];
    updateOffset();
    updateShowPopupIndex(index);
    item.toggle(true);
  };

  var onToggleItem = function onToggleItem(active) {
    childrenRefs.forEach(function (child, index) {
      if (index === active) {
        // 且连续点击同一个dropdown-menu__bar时，显示or隐藏
        if (active === showPopupIndexRef.current) {
          updateShowPopupIndex(null);
          child.toggle();
          return;
        }

        showItem(active);
      } else {
        child.toggle(false, {
          immediate: false
        });
      }
    });
  };

  var renderTitle = function renderTitle(item, index) {
    var showPopup = showPopupIndex === index;
    var disabled = item.disabled,
        titleClass = item.titleClass;
    return /*#__PURE__*/_react().default.createElement("div", {
      key: index,
      role: "button",
      tabIndex: disabled ? -1 : 0,
      className: (0, _classnames2().default)(bem('item', {
        disabled: disabled
      }), (0, _defineProperty2().default)({}, _constant.HAPTICS_FEEDBACK, !disabled)),
      onClick: function onClick() {
        if (!disabled) {
          onToggleItem(index);
        }
      }
    }, /*#__PURE__*/_react().default.createElement("span", {
      className: (0, _classnames2().default)(bem('title', {
        down: showPopup === (props.direction === 'down'),
        active: showPopup
      }), titleClass),
      style: {
        color: showPopup ? props.activeColor : ''
      }
    }, /*#__PURE__*/_react().default.createElement("div", {
      className: "rc-ellipsis"
    }, item.renderTitle())));
  };

  (0, _useClickAway.default)(root, onClickAway);
  (0, _useEventListener.default)('scroll', onScroll, {
    target: scrollParent
  });

  var handleChange = function handleChange(value) {
    var _props$onChange;

    if (titleFlag) {
      setTitleFlag(false);
    } else {
      setTitleFlag(true);
    }

    updateShowPopupIndex(null);
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, value);
  };

  return /*#__PURE__*/_react().default.createElement(DropdownMenuContext.Provider, {
    value: {
      props: props,
      offset: offsetRef.current,
      onChange: handleChange,
      close: closeAll
    }
  }, /*#__PURE__*/_react().default.createElement("div", {
    ref: root,
    className: (0, _classnames2().default)(bem(), props.className),
    style: _objectSpread({}, props.style)
  }, /*#__PURE__*/_react().default.createElement("div", {
    ref: barRef,
    style: barStyle(),
    className: (0, _classnames2().default)(bem('bar', {
      opened: opened
    }))
  }, childrenRefs.map(renderTitle)), _react().default.Children.toArray(props.children).filter(Boolean).map(function (child, index) {
    return /*#__PURE__*/_react().default.cloneElement(child, {
      ref: setChildrenRefs(index)
    });
  })));
});
DropdownMenu.defaultProps = {
  duration: 200,
  overlay: true,
  direction: 'down',
  zIndex: 2000,
  closeOnClickOutside: true,
  closeOnClickOverlay: true,
  shouldRenderTitle: false
};
DropdownMenu.displayName = 'DropdownMenu';
var _default = DropdownMenu;
exports.default = _default;