"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

function _react2() {
  var data = require("@use-gesture/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

function _web() {
  var data = require("@react-spring/web");

  _web = function _web() {
    return data;
  };

  return data;
}

var _image = _interopRequireDefault(require("../image"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ImagePreviewItem = function ImagePreviewItem(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('image-preview', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useSpring = (0, _web().useSpring)(function () {
    return {
      zoom: 1,
      x: 0,
      y: 0,
      config: {
        tension: 300
      }
    };
  }),
      _useSpring2 = (0, _slicedToArray2().default)(_useSpring, 2),
      _useSpring2$ = _useSpring2[0],
      zoom = _useSpring2$.zoom,
      x = _useSpring2$.x,
      y = _useSpring2$.y,
      api = _useSpring2[1];

  var bind = (0, _react2().useGesture)({
    onDrag: function onDrag(state) {
      if (state.tap && state.elapsedTime > 0) {
        // 判断点击时间>0是为了过滤掉非正常操作，例如用户长按选择图片之后的取消操作（也是一次点击）
        props.onTap();
        return;
      }

      var _state$swipe = (0, _slicedToArray2().default)(state.swipe, 2),
          swipeX = _state$swipe[0],
          swipeY = _state$swipe[1];

      var currentZoom = zoom.get();

      if (currentZoom <= 1 || swipeX !== 0 || swipeY !== 0) {
        api.start({
          x: 0,
          y: 0,
          immediate: true
        });
      } else {
        var _state$offset = (0, _slicedToArray2().default)(state.offset, 2),
            offsetX = _state$offset[0],
            offsetY = _state$offset[1];

        api.start({
          x: offsetX,
          y: offsetY,
          immediate: true
        });
      }
    },
    onPinch: function onPinch(state) {
      var _props$onZoomChange;

      var _state$offset2 = (0, _slicedToArray2().default)(state.offset, 1),
          offsetX = _state$offset2[0];

      var currentZoom = state.last ? Math.max(Math.min(offsetX, props.maxZoom), 1) : offsetX;
      api.start({
        zoom: currentZoom,
        immediate: !state.last
      });
      (_props$onZoomChange = props.onZoomChange) === null || _props$onZoomChange === void 0 ? void 0 : _props$onZoomChange.call(props, currentZoom);

      if (state.last && currentZoom <= 1) {
        api.start({
          x: 0,
          y: 0,
          immediate: true
        });
      }
    }
  }, {
    drag: {
      from: function from() {
        return [x.get(), y.get()];
      }
    },
    pinch: {
      distanceBounds: {
        min: 1,
        max: props.maxZoom
      },
      rubberband: true,
      from: function from() {
        return [zoom.get(), 0];
      }
    }
  });
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('slide')),
    "data-testid": "slide",
    onPointerMove: function onPointerMove(e) {
      if (zoom.get() !== 1) {
        e.stopPropagation();
      }
    }
  }, /*#__PURE__*/_react().default.createElement("div", (0, _extends2().default)({
    className: (0, _classnames().default)(bem('control'))
  }, bind(), {
    "data-testid": "control"
  }), /*#__PURE__*/_react().default.createElement(_web().animated.div, {
    className: (0, _classnames().default)(bem('image-wrapper')),
    style: {
      scale: zoom,
      x: x,
      y: y
    }
  }, /*#__PURE__*/_react().default.createElement(_image.default, {
    fit: "contain",
    src: props.image,
    className: (0, _classnames().default)(bem('image')),
    onClick: function onClick() {
      var _props$onTap;

      (_props$onTap = props.onTap) === null || _props$onTap === void 0 ? void 0 : _props$onTap.call(props);
    }
  }))));
};

var _default = ImagePreviewItem;
exports.default = _default;