"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("./utils");

var _useEventVisible3 = _interopRequireDefault(require("./utils/useEventVisible"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _excluded = ["className", "type", "style", "image", "errorImage", "loading", "eventOptions", "height", "width", "onLoaded"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var LazyloadImage = function LazyloadImage(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('lazyload-image', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var className = props.className,
      type = props.type,
      incomingStyle = props.style,
      image = props.image,
      errorImage = props.errorImage,
      loading = props.loading,
      eventOptions = props.eventOptions,
      height = props.height,
      width = props.width,
      onLoaded = props.onLoaded,
      restProps = (0, _objectWithoutProperties2().default)(props, _excluded);

  var _useEventVisible = (0, _useEventVisible3.default)(eventOptions),
      _useEventVisible2 = (0, _slicedToArray2().default)(_useEventVisible, 2),
      containerRef = _useEventVisible2[0],
      visible = _useEventVisible2[1];

  (0, _react().useEffect)(function () {
    if (visible && containerRef.current) {
      var target = containerRef.current;
      var url = target.dataset.src || '';
      (0, _utils.loadImage)(url).catch(function () {
        (0, _utils.setImage)(target, errorImage);
        (0, _utils.addCssClassName)(target, bem('error'));
      }).then(function (imagePath) {
        var _props$onLoaded;

        (0, _utils.setImage)(target, imagePath);
        (0, _utils.addCssClassName)(target, bem('loaded'));
        target.setAttribute('lazy', 'loaded');
        target.removeAttribute('data-src');
        (_props$onLoaded = props.onLoaded) === null || _props$onLoaded === void 0 ? void 0 : _props$onLoaded.call(props);
      });
    }
  }, [visible]);

  var style = _objectSpread(_objectSpread({}, incomingStyle), {}, {
    height: height,
    width: width
  });

  return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, type === 'image' ? /*#__PURE__*/(0, _react().createElement)('img', _objectSpread(_objectSpread({}, restProps), {}, {
    ref: containerRef,
    style: style,
    'data-src': image,
    src: loading || _utils.DEFAULT_URL,
    className: (0, _classnames().default)(bem(), className)
  })) : /*#__PURE__*/(0, _react().createElement)('div', _objectSpread(_objectSpread({}, restProps), {}, {
    ref: containerRef,
    style: style,
    'data-src': image,
    className: (0, _classnames().default)(bem(), className)
  }), props.children));
};

LazyloadImage.defaultProps = {
  loading: null,
  eventOptions: {
    listenEvents: _utils.DEFAULT_EVENTS,
    scrollContainer: document.body,
    offset: 0,
    debounce: 300,
    throttle: 0
  },
  type: 'image',
  errorImage: _utils.DEFAULT_URL
};
var _default = LazyloadImage;
exports.default = _default;