import React from 'react';
import { BaseTypeProps } from '../utils';
export declare type ListenEvent = 'scroll' | 'wheel' | 'mousewheel' | 'resize' | 'animationend' | 'transitionend' | 'touchmove';
export declare type IntersectionObserverEntryType = IntersectionObserverEntry & {
    isIntersecting: boolean;
};
export declare type ObserverOptions = {
    root?: Element;
    rootMargin?: string;
    threshold?: number | number[];
};
export declare type EventOptions = {
    scrollContainer?: HTMLElement;
    offset?: number;
    listenEvents?: ListenEvent[];
    debounce?: number;
    throttle?: number;
};
export declare type LazyLoadImageType = 'image' | 'background';
interface CommonProps extends BaseTypeProps {
    /**
     * 是否使用 IntersectionObserver
     * 默认为 `true`，不支持时自动转为event
     */
    observer?: boolean;
    forceVisible?: boolean;
    eventOptions?: EventOptions;
    observerOptions?: ObserverOptions;
}
export declare type LazyloadProps = {
    children?: React.ReactNode;
    /** 加载时的组件 */
    loading?: React.ReactNode;
    /** 占位高度 */
    height?: string | number;
} & CommonProps;
export declare type ImageProps = BaseTypeProps & {
    image: string;
    loading?: string;
    type?: LazyLoadImageType;
    errorImage?: string;
    onLoaded?: () => void;
} & CommonProps;
export declare type LazyloadImageProps = (React.HTMLAttributes<HTMLImageElement> | React.HTMLAttributes<HTMLDivElement>) & ImageProps & {
    height?: number | string;
    width?: number | string;
};
export declare type LazyloadEventProps = {
    children?: React.ReactNode;
    loading?: React.ReactNode;
    height?: string | number;
} & BaseTypeProps & EventOptions;
export {};
