"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = require("react");

  _react = function _react() {
    return data;
  };

  return data;
}

var _ = require(".");

var _useIntersectionObserver = _interopRequireDefault(require("./useIntersectionObserver"));

var defaultObserverOptions = {
  threshold: [0, 1]
};

var useImageVisible = function useImageVisible() {
  var observerOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultObserverOptions;
  var errorImage = arguments.length > 1 ? arguments[1] : undefined;

  var _useState = (0, _react().useState)(false),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      isLoaded = _useState2[0],
      setIsLoaded = _useState2[1];

  var handleIntersection = (0, _react().useCallback)(function (entries) {
    entries.filter(function (entry) {
      return entry.isIntersecting;
    }).forEach(function (entry) {
      var target = entry.target;
      var url = target.dataset.src || '';
      (0, _.loadImage)(url).catch(function () {
        (0, _.setImage)(target, errorImage);
        (0, _.addCssClassName)(target, 'rc-lazyload__error');
        target.setAttribute('lazy', 'error');
      }).then(function (imagePath) {
        (0, _.setImage)(target, imagePath);
        setIsLoaded(true);
        (0, _.addCssClassName)(target, 'rc-lazyload__loaded');
        target.setAttribute('lazy', 'loaded');
        target.removeAttribute('data-src');
      });
    });
  }, [setIsLoaded, isLoaded]);
  var ref = (0, _useIntersectionObserver.default)(observerOptions, handleIntersection);
  return [ref, isLoaded];
};

var _default = useImageVisible;
exports.default = _default;