"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = require("react");

  _react = function _react() {
    return data;
  };

  return data;
}

var _ = require(".");

var _useIntersectionObserver = _interopRequireDefault(require("./useIntersectionObserver"));

var defaultObserverOptions = {
  threshold: [0, 1]
};

var useVisible = function useVisible(initialVisible) {
  var observerOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultObserverOptions;

  var _useState = (0, _react().useState)(initialVisible),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var forceVisible = function forceVisible() {
    setVisible(true);
  };

  (0, _react().useEffect)(function () {
    if (initialVisible) {
      forceVisible();
    }
  }, [initialVisible]);
  var handleIntersection = (0, _react().useCallback)(function (entries) {
    entries.filter(function (entry) {
      return entry.isIntersecting;
    }).forEach(function (entry) {
      var target = entry.target;
      (0, _.addCssClassName)(target, 'rc-lazyload__loaded');
      setVisible(true);
    });
  }, [setVisible, visible]);
  var ref = (0, _useIntersectionObserver.default)(observerOptions, handleIntersection);
  return [ref, visible];
};

var _default = useVisible;
exports.default = _default;