"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _popup = require("../popup");

var _utils = require("./utils");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _NumberKeyboardKey = _interopRequireDefault(require("./NumberKeyboardKey"));

var _useClickAway = _interopRequireDefault(require("../hooks/use-click-away"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var NumberKeyboard = function NumberKeyboard(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('number-keyboard', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var visible = props.visible,
      safeAreaInsetBottom = props.safeAreaInsetBottom,
      theme = props.theme,
      blurOnClose = props.blurOnClose,
      showDeleteKey = props.showDeleteKey,
      hideOnClickOutside = props.hideOnClickOutside,
      zIndex = props.zIndex,
      teleport = props.teleport,
      title = props.title,
      closeButtonText = props.closeButtonText,
      titleLeft = props.titleLeft;
  var root = (0, _react().useRef)(null);
  var showClose = closeButtonText && theme === 'default';
  var showTitle = !!(title || showClose || titleLeft);
  var keys = (0, _react().useMemo)(function () {
    return theme === 'custom' ? (0, _utils.genCustomKeys)(props) : (0, _utils.genDefaultKeys)(props);
  }, [theme]);

  var onBlur = function onBlur() {
    if (visible) {
      var _props$onBlur;

      (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 ? void 0 : _props$onBlur.call(props);
    }
  };

  var onClose = function onClose() {
    var _props$onClose;

    (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props);

    if (blurOnClose) {
      onBlur();
    }
  };

  var onPress = function onPress(text, type) {
    if (text === '') {
      if (type === 'extra') {
        onBlur();
      }

      return;
    }

    if (type === 'delete') {
      var _props$onDelete;

      (_props$onDelete = props.onDelete) === null || _props$onDelete === void 0 ? void 0 : _props$onDelete.call(props);
    } else if (type === 'close') {
      onClose();
    } else {
      var _props$onInput;

      (_props$onInput = props.onInput) === null || _props$onInput === void 0 ? void 0 : _props$onInput.call(props, text);
    }
  };

  var renderTitle = function renderTitle() {
    if (!showTitle) {
      return null;
    }

    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('header'))
    }, titleLeft && /*#__PURE__*/_react().default.createElement("span", {
      className: (0, _classnames().default)(bem('title-left'))
    }, titleLeft), title && /*#__PURE__*/_react().default.createElement("h2", {
      className: (0, _classnames().default)(bem('title'))
    }, title), showClose && /*#__PURE__*/_react().default.createElement("button", {
      type: "button",
      className: (0, _classnames().default)(bem('close')),
      onClick: onClose
    }, closeButtonText));
  };

  var renderKeys = function renderKeys() {
    return keys.map(function (key) {
      return /*#__PURE__*/_react().default.createElement(_NumberKeyboardKey.default, {
        key: "".concat(key.text).concat(key.type),
        text: key.text,
        type: key.type,
        wider: key.wider,
        color: key.color,
        onPress: onPress
      });
    });
  };

  var renderSidebar = function renderSidebar() {
    if (theme === 'custom') {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('sidebar'))
      }, showDeleteKey && /*#__PURE__*/_react().default.createElement(_NumberKeyboardKey.default, {
        large: true,
        text: props.deleteButtonText,
        type: "delete",
        onPress: onPress
      }), /*#__PURE__*/_react().default.createElement(_NumberKeyboardKey.default, {
        large: true,
        text: props.closeButtonText,
        type: "close",
        color: "blue",
        loading: props.closeButtonLoading,
        onPress: onPress
      }));
    }

    return null;
  };

  (0, _useClickAway.default)(root, onBlur, 'touchstart', hideOnClickOutside);
  return /*#__PURE__*/_react().default.createElement(_popup.Popup, {
    visible: visible,
    preventDefaultMouseDown: true,
    overlay: false,
    round: showTitle,
    zIndex: zIndex,
    position: "bottom",
    duration: 300,
    teleport: teleport,
    safeAreaInsetBottom: safeAreaInsetBottom,
    onClose: onClose
  }, /*#__PURE__*/_react().default.createElement("div", {
    ref: root,
    className: (0, _classnames().default)(bem())
  }, renderTitle(), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('body'))
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('keys'))
  }, renderKeys()), renderSidebar())));
};

NumberKeyboard.defaultProps = {
  theme: 'default',
  visible: false,
  extraKey: '',
  showDeleteKey: true,
  zIndex: 100,
  closeButtonLoading: false,
  hideOnClickOutside: true,
  randomKeyOrder: false,
  safeAreaInsetBottom: true,
  blurOnClose: true
};
var _default = NumberKeyboard;
exports.default = _default;