"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _constant = require("../utils/constant");

var _utils = require("../utils");

var _useUpdateEffect = _interopRequireDefault(require("../hooks/use-update-effect"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var DEFAULT_CELL_LENGTH = 6;
var PasswordInput = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('password-input', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var rootRef = (0, _react().useRef)(null);
  var nativeInputRef = (0, _react().useRef)(null);

  var _useState = (0, _react().useState)(props.value),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      inputValue = _useState2[0],
      setInputValue = _useState2[1];

  var length = props.length,
      value = props.value,
      focused = props.focused;
  var info = props.errorInfo || props.info;
  var cellLength = length > 0 && length < Infinity ? Math.floor(length) : DEFAULT_CELL_LENGTH;
  (0, _useUpdateEffect.default)(function () {
    if (['', undefined].includes(value)) {
      setInputValue('');
    }

    setInputValue(value.slice(0, cellLength));
  }, [value, cellLength]);
  (0, _react().useEffect)(function () {
    var _props$onChange;

    if (inputValue.length >= cellLength) {
      var _props$onFill;

      (_props$onFill = props.onFill) === null || _props$onFill === void 0 ? void 0 : _props$onFill.call(props, inputValue);
    }

    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, inputValue.slice(0, cellLength));
  }, [props.onChange, props.onFill, inputValue, cellLength]);

  var onFocus = function onFocus() {
    var _props$onFocus;

    if (!props.keyboard) {
      var _nativeInputRef$curre;

      (_nativeInputRef$curre = nativeInputRef.current) === null || _nativeInputRef$curre === void 0 ? void 0 : _nativeInputRef$curre.focus();
    }

    (_props$onFocus = props.onFocus) === null || _props$onFocus === void 0 ? void 0 : _props$onFocus.call(props);
  };

  var onBlur = function onBlur() {
    var _props$onBlur;

    (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 ? void 0 : _props$onBlur.call(props);
  };

  (0, _react().useImperativeHandle)(ref, function () {
    return {
      focus: function focus() {
        return onFocus();
      },
      blur: function blur() {
        var _nativeInputRef$curre2;

        onBlur();
        (_nativeInputRef$curre2 = nativeInputRef.current) === null || _nativeInputRef$curre2 === void 0 ? void 0 : _nativeInputRef$curre2.blur();
      }
    };
  });

  var onTouchStart = function onTouchStart(event) {
    var _props$onFocus2;

    event.stopPropagation();
    (_props$onFocus2 = props.onFocus) === null || _props$onFocus2 === void 0 ? void 0 : _props$onFocus2.call(props);
  };

  var renderPoints = function renderPoints() {
    var Points = [];
    var mask = props.mask,
        gutter = props.gutter;

    for (var i = 0; i < length; i++) {
      var _char = inputValue[i];
      var showBorder = i !== 0 && !gutter;
      var showCursor = focused && i === inputValue.length;
      var style = void 0;

      if (i !== 0 && gutter) {
        style = {
          marginLeft: (0, _utils.addUnit)(gutter)
        };
      }

      Points.push( /*#__PURE__*/_react().default.createElement("li", {
        key: i,
        className: (0, _classnames().default)((0, _defineProperty2().default)({}, _constant.BORDER_LEFT, showBorder), bem('item', {
          focus: showCursor
        })),
        style: style
      }, mask ? /*#__PURE__*/_react().default.createElement("i", {
        style: {
          visibility: _char ? 'visible' : 'hidden'
        }
      }) : _char, showCursor && /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('cursor'))
      })));
    }

    return Points;
  };

  return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, /*#__PURE__*/_react().default.createElement("div", {
    ref: rootRef // eslint-disable-next-line jsx-a11y/no-noninteractive-tabindex
    ,
    tabIndex: 0,
    onFocus: onFocus,
    onBlur: onBlur,
    className: (0, _classnames().default)(bem())
  }, /*#__PURE__*/_react().default.createElement("ul", {
    className: (0, _classnames().default)(bem('security'), (0, _defineProperty2().default)({}, _constant.BORDER_SURROUND, !props.gutter)),
    onTouchStart: onTouchStart
  }, renderPoints()), info && /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem(props.errorInfo ? 'error-info' : 'info'))
  }, info), /*#__PURE__*/_react().default.createElement("input", {
    ref: nativeInputRef,
    className: (0, _classnames().default)(bem('native-input')),
    value: inputValue,
    type: "text",
    pattern: "[0-9]*",
    inputMode: "numeric",
    onChange: function onChange(e) {
      setInputValue(e.target.value.slice(0, props.length));
    }
  })), props.keyboard && /*#__PURE__*/_react().default.cloneElement(props.keyboard, {
    visible: focused,
    onInput: function onInput(v) {
      if (inputValue.length < cellLength) {
        setInputValue((inputValue + v).slice(0, props.length));
      }
    },
    onDelete: function onDelete() {
      setInputValue(inputValue.slice(0, -1));
    },
    onClose: function onClose() {
      var _rootRef$current;

      (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 ? void 0 : _rootRef$current.blur();
    },
    onBlur: function onBlur() {
      var _rootRef$current2;

      (_rootRef$current2 = rootRef.current) === null || _rootRef$current2 === void 0 ? void 0 : _rootRef$current2.blur();
    }
  }));
});
PasswordInput.defaultProps = {
  value: '',
  info: null,
  errorInfo: null,
  length: DEFAULT_CELL_LENGTH,
  gutter: 0,
  mask: true,
  focused: false,
  onChange: function onChange() {}
};
var _default = PasswordInput;
exports.default = _default;