"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _typeof2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

  _typeof2 = function _typeof2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _PickerColumn = _interopRequireDefault(require("./PickerColumn"));

var _loading = require("../loading");

var _useRefs3 = _interopRequireDefault(require("../hooks/use-refs"));

var _utils = require("../utils");

var _constant = require("../utils/constant");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _useEventListener = _interopRequireDefault(require("../hooks/use-event-listener"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Picker = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('picker', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useRefs = (0, _useRefs3.default)(),
      _useRefs2 = (0, _slicedToArray2().default)(_useRefs, 2),
      refs = _useRefs2[0],
      setRefs = _useRefs2[1];

  var _useState = (0, _react().useState)([]),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      formattedColumns = _useState2[0],
      setFormattedColumns = _useState2[1];

  var _extend = (0, _utils.extend)({
    // compatible with valueKey prop
    text: 'text',
    values: 'values',
    children: 'children'
  }, props.columnsFieldNames),
      textKey = _extend.text,
      valuesKey = _extend.values,
      childrenKey = _extend.children;

  var wrapper = (0, _react().useRef)(null);
  var itemHeight = (0, _react().useMemo)(function () {
    return (0, _utils.unitToPx)(props.itemHeight);
  }, [props.itemHeight]);
  var dataType = (0, _react().useMemo)(function () {
    var columns = props.columns;
    var firstColumn = columns[0] || {};

    if ((0, _typeof2().default)(firstColumn) === 'object') {
      if (childrenKey in firstColumn) {
        return 'cascade';
      }

      if (valuesKey in firstColumn) {
        return 'object';
      }
    }

    return 'plain';
  }, [props.columns]);

  var formatCascade = function formatCascade() {
    var formatted = [];
    var cursor = (0, _defineProperty2().default)({}, childrenKey, props.columns);

    while (cursor && cursor[childrenKey]) {
      var _cursor$defaultIndex, _formatted$push;

      var children = cursor[childrenKey];
      var defaultIndex = (_cursor$defaultIndex = cursor.defaultIndex) !== null && _cursor$defaultIndex !== void 0 ? _cursor$defaultIndex : +props.defaultIndex;

      while (children[defaultIndex] && children[defaultIndex].disabled) {
        if (defaultIndex < children.length - 1) {
          defaultIndex++;
        } else {
          defaultIndex = 0;
          break;
        }
      }

      formatted.push((_formatted$push = {}, (0, _defineProperty2().default)(_formatted$push, valuesKey, cursor[childrenKey]), (0, _defineProperty2().default)(_formatted$push, "className", cursor.className), (0, _defineProperty2().default)(_formatted$push, "defaultIndex", defaultIndex), _formatted$push));
      cursor = children[defaultIndex];
    }

    setFormattedColumns(formatted);
  };

  var format = function format() {
    var columns = props.columns;

    if (dataType === 'plain') {
      setFormattedColumns([(0, _defineProperty2().default)({}, valuesKey, columns)]);
    } else if (dataType === 'cascade') {
      formatCascade();
    } else {
      setFormattedColumns(columns);
    }
  }; // get indexes of all columns


  var getIndexes = function getIndexes() {
    return refs.map(function (_ref) {
      return _ref.getIndex();
    });
  }; // set options of column by index


  var setColumnValues = function setColumnValues(index, options) {
    var column = refs[index];

    if (column) {
      column.setOptions(options);
    }
  };

  var onCascadeChange = function onCascadeChange(columnIndex) {
    var cursor = (0, _defineProperty2().default)({}, childrenKey, props.columns);
    var indexes = getIndexes();

    for (var i = 0; i <= columnIndex; i += 1) {
      cursor = cursor[childrenKey][indexes[i]];
    }

    while (cursor && cursor[childrenKey]) {
      columnIndex += 1;
      setColumnValues(columnIndex, cursor[childrenKey]);
      cursor = cursor[childrenKey][cursor.defaultIndex || 0];
    }
  }; // get column instance by index


  var getChild = function getChild(index) {
    return refs[index];
  }; // get column value by index


  var getColumnValue = function getColumnValue(index) {
    var column = getChild(index);
    return (column === null || column === void 0 ? void 0 : column.getValue()) || undefined;
  }; // set column value by index


  var setColumnValue = function setColumnValue(index, value) {
    var column = getChild(index);

    if (column) {
      column.setValue(value);

      if (dataType === 'cascade') {
        onCascadeChange(index);
      }
    }
  }; // get column option index by column index


  var getColumnIndex = function getColumnIndex(index) {
    var column = getChild(index);
    return (column === null || column === void 0 ? void 0 : column.getIndex()) || 0;
  }; // set column option index by column index


  var setColumnIndex = function setColumnIndex(columnIndex, optionIndex) {
    var column = getChild(columnIndex);

    if (column) {
      column.setIndex(optionIndex);

      if (dataType === 'cascade') {
        onCascadeChange(columnIndex);
      }
    }
  }; // get options of column by index


  var getColumnValues = function getColumnValues(index) {
    var column = getChild(index);
    return column === null || column === void 0 ? void 0 : column.getOptions();
  }; // get values of all columns


  var getValues = function getValues() {
    return refs.map(function (_ref) {
      return _ref.getValue();
    });
  }; // set values of all columns


  var setValues = function setValues(values) {
    values.forEach(function (value, index) {
      setColumnValue(index, value);
    });
  }; // set indexes of all columns


  var setIndexes = function setIndexes(indexes) {
    indexes.forEach(function (optionIndex, columnIndex) {
      setColumnIndex(columnIndex, optionIndex);
    });
  };

  var _onChange = function onChange(columnIndex) {
    if (dataType === 'cascade') {
      onCascadeChange(columnIndex);
    }

    if (props.onChange) {
      if (dataType === 'plain') {
        props.onChange(getColumnValue(0), getColumnIndex(0));
      } else {
        props.onChange(getValues(), columnIndex);
      }
    }
  };

  var confirm = function confirm() {
    if (props.onConfirm) {
      if (dataType === 'plain') {
        props.onConfirm(getColumnValue(0), getColumnIndex(0));
      } else {
        props.onConfirm(getValues(), getIndexes());
      }
    }
  };

  var cancel = function cancel() {
    if (dataType === 'plain') {
      var _props$onCancel;

      (_props$onCancel = props.onCancel) === null || _props$onCancel === void 0 ? void 0 : _props$onCancel.call(props, getColumnValue(0), getColumnIndex(0));
    } else {
      var _props$onCancel2;

      (_props$onCancel2 = props.onCancel) === null || _props$onCancel2 === void 0 ? void 0 : _props$onCancel2.call(props, getValues(), getIndexes());
    }
  };

  var renderTitle = function renderTitle() {
    if (props.title) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('title'), 'rc-ellipsis')
      }, props.title);
    }

    return null;
  };

  var renderCancel = function renderCancel() {
    var text = props.cancelButtonText || '取消';
    return /*#__PURE__*/_react().default.createElement("button", {
      type: "button",
      className: (0, _classnames().default)(bem('cancel')),
      onClick: cancel
    }, text);
  };

  var renderConfirm = function renderConfirm() {
    var text = props.confirmButtonText || '确认';
    return /*#__PURE__*/_react().default.createElement("button", {
      type: "button",
      className: (0, _classnames().default)(bem('confirm')),
      onClick: confirm
    }, text);
  };

  var renderToolbar = function renderToolbar() {
    return props.showToolbar ? /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('toolbar'))
    }, props.toolbar || /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, renderCancel(), renderTitle(), renderConfirm())) : null;
  };

  var renderColumnItems = function renderColumnItems() {
    return formattedColumns.map(function (item, columnIndex) {
      var _item$defaultIndex;

      return /*#__PURE__*/_react().default.createElement(_PickerColumn.default, {
        key: String(columnIndex),
        optionRender: props.optionRender,
        ref: setRefs(columnIndex),
        textKey: textKey,
        readonly: props.readonly,
        className: item.className,
        itemHeight: itemHeight,
        defaultIndex: (_item$defaultIndex = item.defaultIndex) !== null && _item$defaultIndex !== void 0 ? _item$defaultIndex : +props.defaultIndex,
        swipeDuration: props.swipeDuration,
        visibleItemCount: props.visibleItemCount,
        initialOptions: item[valuesKey],
        onChange: function onChange() {
          _onChange(columnIndex);
        }
      });
    });
  };

  var renderColumns = function renderColumns() {
    var wrapHeight = itemHeight * props.visibleItemCount;
    var frameStyle = {
      height: "".concat(itemHeight, "px")
    };
    var columnsStyle = {
      height: "".concat(wrapHeight, "px")
    };
    var maskStyle = {
      backgroundSize: "100% ".concat((wrapHeight - itemHeight) / 2, "px")
    };
    return /*#__PURE__*/_react().default.createElement("div", {
      ref: wrapper,
      className: (0, _classnames().default)(bem('columns')),
      style: columnsStyle
    }, renderColumnItems(), /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('mask')),
      style: maskStyle
    }), /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(_constant.BORDER_UNSET_TOP_BOTTOM, bem('frame')),
      style: frameStyle
    }));
  };

  (0, _react().useEffect)(function () {
    format();
  }, [props.columns]);
  (0, _useEventListener.default)('touchmove', _utils.preventDefault, {
    target: wrapper.current,
    depends: [wrapper.current]
  });
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      confirm: confirm,
      getValues: getValues,
      setValues: setValues,
      getIndexes: getIndexes,
      setIndexes: setIndexes,
      getColumnIndex: getColumnIndex,
      setColumnIndex: setColumnIndex,
      getColumnValue: getColumnValue,
      setColumnValue: setColumnValue,
      getColumnValues: getColumnValues,
      setColumnValues: setColumnValues
    };
  });
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem(), props.className)
  }, props.toolbarPosition === 'top' ? renderToolbar() : null, props.loading ? /*#__PURE__*/_react().default.createElement(_loading.Loading, {
    className: (0, _classnames().default)(bem('loading'))
  }) : null, props.columnsTop, renderColumns(), props.columnsBottom, props.toolbarPosition === 'bottom' ? renderToolbar() : null);
});
Picker.defaultProps = {
  itemHeight: 44,
  visibleItemCount: 5,
  swipeDuration: 1000,
  defaultIndex: 0,
  showToolbar: true,
  toolbarPosition: 'top'
};
Picker.displayName = 'Picker';
var _default = Picker;
exports.default = _default;