"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _web() {
  var data = require("@react-spring/web");

  _web = function _web() {
    return data;
  };

  return data;
}

function _react2() {
  var data = require("@use-gesture/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _hooks = require("../hooks");

var _utils = require("../utils");

var _deepClone = require("../utils/deep-clone");

var _rubberband = require("../utils/rubberband");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function isOptionDisabled(option) {
  return (0, _utils.isObject)(option) && option.disabled;
}

var DEFAULT_DURATION = 200;
var MOMENTUM_LIMIT_DISTANCE = 15;
var PickerColumn = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('picker-column', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var itemHeight = props.itemHeight,
      visibleItemCount = props.visibleItemCount,
      defaultIndex = props.defaultIndex,
      initialOptions = props.initialOptions;
  var root = (0, _react().useRef)(null);
  var wrapper = (0, _react().useRef)(null);
  var indexRef = (0, _react().useRef)(defaultIndex);
  var optionsRef = (0, _react().useRef)((0, _deepClone.deepClone)(initialOptions));

  var _useSetState = (0, _hooks.useSetState)({
    offset: 0,
    duration: 0,
    options: (0, _deepClone.deepClone)(initialOptions)
  }),
      _useSetState2 = (0, _slicedToArray2().default)(_useSetState, 2),
      state = _useSetState2[0],
      updateState = _useSetState2[1];

  var count = (0, _react().useMemo)(function () {
    return optionsRef.current.length;
  }, [optionsRef.current.length]);
  var baseOffset = (0, _react().useMemo)(function () {
    // 默认转入第一个选项的位置
    return itemHeight * (+visibleItemCount - 1) / 2;
  }, [itemHeight, visibleItemCount]);
  var draggingRef = (0, _react().useRef)(false);

  var _useSpring = (0, _web().useSpring)(function () {
    return {
      from: {
        y: defaultIndex * -itemHeight + baseOffset
      },
      config: {
        tension: 400,
        mass: 0.8
      }
    };
  }),
      _useSpring2 = (0, _slicedToArray2().default)(_useSpring, 2),
      y = _useSpring2[0].y,
      api = _useSpring2[1];

  var adjustIndex = function adjustIndex(index) {
    index = (0, _utils.range)(index, 0, count);

    for (var i = index; i < count; i += 1) {
      if (!isOptionDisabled(optionsRef.current[i])) return i;
    } // for (let i = index - 1; i >= 0; i -= 1) {
    //   if (!isOptionDisabled(optionsRef.current[i])) return i;
    // }


    return null;
  };

  var setIndex = function setIndex(index, emitChange) {
    index = adjustIndex(index) || 0;
    var offset = index * -itemHeight;
    api.start({
      y: offset + baseOffset
    });

    if (index !== indexRef.current) {
      indexRef.current = index; // updateState({ index });

      if (emitChange && props.onChange) {
        setTimeout(function () {
          props.onChange(index);
        }, 0);
      }
    }

    updateState({
      offset: offset
    });
  };

  var setOptions = function setOptions(options) {
    if (JSON.stringify(options) !== JSON.stringify(optionsRef.current)) {
      optionsRef.current = options;
      setIndex(props.defaultIndex);
    }
  };

  var onClickItem = function onClickItem(index) {
    if (draggingRef.current || props.readonly) {
      return;
    }

    updateState({
      duration: DEFAULT_DURATION
    });
    setIndex(index, true);
  };

  var getOptionText = function getOptionText(option) {
    if ((0, _utils.isObject)(option) && props.textKey in option) {
      return option[props.textKey];
    }

    return option;
  };

  var getIndexByOffset = function getIndexByOffset(offset) {
    return (0, _utils.range)(Math.round(-offset / props.itemHeight), 0, count - 1);
  };

  var bind = (0, _react2().useDrag)(function (dragState) {
    if (props.readonly) {
      return;
    }

    draggingRef.current = true;

    if (dragState.tap) {
      updateState({
        duration: 0,
        offset: dragState.offset[1]
      });
    } else if (dragState.last) {
      var allowMomentum = Math.abs(dragState.velocity[1] * dragState.direction[1] * 50) > MOMENTUM_LIMIT_DISTANCE;
      var position = dragState.offset[1] + dragState.velocity[1] * dragState.direction[1] * 50 - baseOffset;
      var targetIndex = getIndexByOffset(position);
      updateState({
        duration: allowMomentum ? +props.swipeDuration : DEFAULT_DURATION,
        offset: position + baseOffset
      });
      setIndex(targetIndex, true);
    } else {
      var _position = dragState.offset[1];
      var max = baseOffset;
      var min = -(count * itemHeight) + baseOffset; // const offset = range(position, -(count * itemHeight), itemHeight);

      var offset = (0, _rubberband.rubberbandIfOutOfBounds)(_position, min, max, itemHeight * 50, 0.2);
      api.start({
        y: offset
      });
    }
  }, {
    axis: 'y',
    from: function from() {
      return [0, y.get()];
    },
    filterTaps: true,
    pointer: {
      touch: true
    }
  });
  var renderOptions = (0, _react().useMemo)(function () {
    var optionStyle = {
      height: "".concat(props.itemHeight, "px")
    };
    return optionsRef.current.map(function (option, index) {
      var text = getOptionText(option);
      var disabled = isOptionDisabled(option);
      var data = {
        role: 'button',
        key: index,
        style: optionStyle,
        tabIndex: disabled ? -1 : 0,
        className: (0, _classnames().default)(bem('item', {
          disabled: disabled,
          selected: index === indexRef.current
        })),
        onClick: function onClick() {
          draggingRef.current = false;
          onClickItem(index);
        }
      };
      var childData = {
        className: 'rc-ellipsis',
        children: text
      };
      return /*#__PURE__*/_react().default.createElement("li", data, props.optionRender ? props.optionRender(option) : /*#__PURE__*/_react().default.createElement("div", childData));
    });
  }, [optionsRef.current, indexRef.current, onClickItem, props.optionRender]);

  var setValue = function setValue(value) {
    var options = optionsRef.current;

    for (var i = 0; i < options.length; i += 1) {
      if (getOptionText(options[i]) === value) {
        return setIndex(i);
      }
    }

    return null;
  };

  var getValue = (0, _react().useCallback)(function () {
    return optionsRef.current[indexRef.current];
  }, [indexRef.current, optionsRef.current]);
  (0, _react().useEffect)(function () {
    setIndex(defaultIndex);
  }, [defaultIndex]);
  (0, _hooks.useUpdateEffect)(function () {
    setOptions((0, _deepClone.deepClone)(initialOptions));
  }, [initialOptions]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      state: state,
      getIndex: function getIndex() {
        return indexRef.current;
      },
      getOptions: function getOptions() {
        return optionsRef.current;
      },
      setIndex: setIndex,
      getValue: getValue,
      setValue: setValue,
      setOptions: setOptions
    };
  });
  return /*#__PURE__*/_react().default.createElement("div", (0, _extends2().default)({
    ref: root,
    className: (0, _classnames().default)(bem(), props.className)
  }, bind()), /*#__PURE__*/_react().default.createElement(_web().animated.ul, {
    ref: wrapper,
    className: (0, _classnames().default)(bem('wrapper')),
    style: {
      y: y,
      transitionDuration: "".concat(state.duration, "ms"),
      transitionProperty: state.duration ? 'all' : 'none'
    },
    "aria-hidden": true
  }, renderOptions));
});
PickerColumn.defaultProps = {
  initialOptions: [],
  defaultIndex: 0
};
PickerColumn.displayName = 'PickerColumn';
var _default = PickerColumn;
exports.default = _default;