"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _badge = require("../badge");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _SidebarContext = _interopRequireDefault(require("./SidebarContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SidebarItem = function SidebarItem(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('sidebar-item', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var parent = (0, _react().useContext)(_SidebarContext.default);

  if (!Object.prototype.hasOwnProperty.call(parent, 'getActive')) {
    if (process.env.NODE_ENV !== 'production') {
      console.error('[rc-ui-lib] <SidebarItem> must be a child component of <Sidebar>.');
    }

    return null;
  }

  var dot = props.dot,
      badge = props.badge,
      title = props.title,
      disabled = props.disabled,
      index = props.index;
  var selected = index === parent.getActive();

  var onClick = function onClick() {
    var _props$onClick;

    if (props.disabled) {
      return;
    }

    (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, index);
    parent.setActive(index);
  };

  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/interactive-supports-focus
    _react().default.createElement("div", {
      role: "tab",
      tabIndex: disabled ? undefined : 0,
      className: (0, _classnames().default)(bem({
        select: selected,
        disabled: disabled
      })),
      "aria-selected": selected,
      onClick: onClick
    }, /*#__PURE__*/_react().default.createElement(_badge.Badge, {
      dot: dot,
      content: badge,
      className: (0, _classnames().default)(bem('text'))
    }, props.children ? props.children : title))
  );
};

var _default = SidebarItem;
exports.default = _default;