"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

function _web() {
  var data = require("@react-spring/web");

  _web = function _web() {
    return data;
  };

  return data;
}

function _react2() {
  var data = require("@use-gesture/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _pageIndicator = require("./page-indicator");

var _SwiperItem = _interopRequireDefault(require("./SwiperItem"));

var _useRefState3 = _interopRequireDefault(require("../hooks/use-ref-state"));

var _bound = require("../utils/bound");

var _devLog = require("../utils/dev-log");

var _utils = require("../utils");

var _getRect = require("../hooks/get-rect");

var _useMountedRef = _interopRequireDefault(require("../hooks/use-mounted-ref"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function modulus(value, division) {
  var remainder = value % division;
  return remainder < 0 ? remainder + division : remainder;
}

var Swiper = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('swiper', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var outerLoop = props.loop,
      autoplay = props.autoplay,
      direction = props.direction,
      autoplayInterval = props.autoplayInterval;

  var _lock = (0, _react().useRef)(false);

  var trackRef = (0, _react().useRef)(null);

  var _useState = (0, _react().useState)(null),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      root = _useState2[0],
      setRoot = _useState2[1];

  var _useState3 = (0, _react().useState)(props.defaultIndex),
      _useState4 = (0, _slicedToArray2().default)(_useState3, 2),
      current = _useState4[0],
      setCurrent = _useState4[1];

  var _useRefState = (0, _useRefState3.default)(false),
      _useRefState2 = (0, _slicedToArray2().default)(_useRefState, 3),
      dragging = _useRefState2[0],
      setDragging = _useRefState2[1],
      draggingRef = _useRefState2[2];

  var isVertical = direction === 'vertical';
  var axis = (0, _react().useMemo)(function () {
    return isVertical ? 'y' : 'x';
  }, [isVertical]);
  var slideRatio = props.slideSize / 100;
  var offsetRatio = props.trackOffset / 100;
  var computedStyle = (0, _react().useMemo)(function () {
    var _objectSpread2;

    return _objectSpread((_objectSpread2 = {}, (0, _defineProperty2().default)(_objectSpread2, "--".concat(prefixCls, "-swipe-slide-size"), "".concat(props.slideSize, "%")), (0, _defineProperty2().default)(_objectSpread2, "--".concat(prefixCls, "-swipe-track-offset"), "".concat(props.trackOffset, "%")), _objectSpread2), props.style);
  }, [props.style, props.slideSize, props.trackOffset]);
  var axisDistance = (0, _react().useMemo)(function () {
    if (!isVertical) return 100;
    var rect = (0, _getRect.getRect)(root);
    return rect.height;
  }, [isVertical, root]);

  var _useMemo = (0, _react().useMemo)(function () {
    var innerCount = 0;

    var innerValidChildren = _react().default.Children.map(props.children, function (child) {
      if (! /*#__PURE__*/_react().default.isValidElement(child)) return null;

      if (child.type !== _SwiperItem.default) {
        (0, _devLog.devWarning)('Swiper', 'The children of `Swiper` must be `Swiper.Item` components.');
        return null;
      }

      innerCount++;
      return child;
    });

    return {
      validChildren: innerValidChildren,
      count: innerCount
    };
  }, [props.children]),
      validChildren = _useMemo.validChildren,
      count = _useMemo.count;

  var loop = (0, _react().useMemo)(function () {
    if (count <= 1) return false;
    return outerLoop;
  }, [count, outerLoop]);
  var mountedRef = (0, _useMountedRef.default)();

  var getSlidePixels = function getSlidePixels() {
    var track = trackRef.current;
    if (!track) return 0;
    var trackPixels = isVertical ? track.offsetHeight : track.offsetWidth;
    return trackPixels * props.slideSize / 100;
  };

  var boundIndex = function boundIndex(cur) {
    var min = 0;
    var max = count - 1;

    if (props.stuckAtBoundary) {
      min += (1 - slideRatio - offsetRatio) / slideRatio;
      max -= (1 - slideRatio - offsetRatio) / slideRatio;
    }

    return (0, _bound.bound)(cur, min, max);
  };

  var _useSpring = (0, _web().useSpring)(function () {
    return {
      position: boundIndex(current) * 100,
      config: {
        tension: 200,
        friction: 30,
        autoplayInterval: autoplayInterval
      },
      onRest: function onRest() {
        if (draggingRef.current) return;
        var rawX = position.get();
        var totalWidth = 100 * count;
        var standardPosition = modulus(rawX, totalWidth);
        if (standardPosition === rawX) return;
        api.start({
          position: standardPosition,
          immediate: true
        });
      }
    };
  }, [count]),
      _useSpring2 = (0, _slicedToArray2().default)(_useSpring, 2),
      position = _useSpring2[0].position,
      api = _useSpring2[1];

  var bind = (0, _react2().useDrag)(function (state) {
    if (_lock.current) return;
    var slidePixels = getSlidePixels();
    if (!slidePixels) return;
    var paramIndex = isVertical ? 1 : 0;
    var offset = state.offset[paramIndex];
    var itemDirection = state.direction[paramIndex];
    var velocity = state.velocity[paramIndex];
    setDragging(true);

    if (!state.last) {
      api.start({
        position: offset * 100 / slidePixels,
        immediate: true
      });
    } else {
      var index = Math.round((offset + Math.min(velocity * 2000, slidePixels) * itemDirection) / slidePixels);
      swipeTo(index);
      window.setTimeout(function () {
        if (mountedRef.current) {
          setDragging(false);
        }
      });
    }
  }, {
    transform: function transform(_ref) {
      var _ref2 = (0, _slicedToArray2().default)(_ref, 2),
          x = _ref2[0],
          y = _ref2[1];

      return [-x, -y];
    },
    from: function from() {
      var slidePixels = getSlidePixels();
      return [position.get() / 100 * slidePixels, position.get() / 100 * slidePixels];
    },
    bounds: function bounds() {
      if (loop) return {};
      var slidePixels = getSlidePixels();
      var lowerBound = boundIndex(0) * slidePixels;
      var upperBound = boundIndex(count - 1) * slidePixels;
      return isVertical ? {
        top: lowerBound,
        bottom: upperBound
      } : {
        left: lowerBound,
        right: upperBound
      };
    },
    rubberband: true,
    axis: axis,
    preventScroll: !isVertical,
    pointer: {
      touch: true
    }
  });

  var renderIndicator = function renderIndicator() {
    if (props.indicator === undefined || props.indicator === true) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('indicator', {
          vertical: isVertical
        }))
      }, /*#__PURE__*/_react().default.createElement(_pageIndicator.PageIndicator, (0, _extends2().default)({}, props.indicatorProps, {
        direction: props.direction,
        total: count,
        current: current
      })));
    }

    if (typeof props.indicator === 'function') {
      return props.indicator(count, current);
    }

    return null;
  };

  var onClickCapture = function onClickCapture(e) {
    if (draggingRef.current) {
      e.stopPropagation();
    }
  };

  function swipeTo(index) {
    var immediate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (loop) {
      var _props$onIndexChange;

      var i = modulus(index, count);
      setCurrent(i);
      (_props$onIndexChange = props.onIndexChange) === null || _props$onIndexChange === void 0 ? void 0 : _props$onIndexChange.call(props, i);
      api.start({
        position: index * 100,
        immediate: immediate
      });
    } else {
      var _props$onIndexChange2;

      var _i = (0, _bound.bound)(index, 0, count - 1);

      setCurrent(_i);
      (_props$onIndexChange2 = props.onIndexChange) === null || _props$onIndexChange2 === void 0 ? void 0 : _props$onIndexChange2.call(props, _i);
      api.start({
        position: boundIndex(_i) * 100,
        immediate: immediate
      });
    }
  }

  var swipeNext = function swipeNext() {
    swipeTo(Math.round(position.get() / 100) + 1);
  };

  var swipePrev = function swipePrev() {
    swipeTo(Math.round(position.get() / 100) - 1);
  };

  (0, _react().useImperativeHandle)(ref, function () {
    return {
      activeIndex: current,
      swipeTo: swipeTo,
      swipeNext: swipeNext,
      swipePrev: swipePrev,
      lock: function lock() {
        _lock.current = true;
      },
      unlock: function unlock() {
        _lock.current = false;
      }
    };
  });
  (0, _react().useEffect)(function () {
    if (!autoplay || dragging) return _utils.noop;
    var interval = window.setInterval(function () {
      swipeNext();
    }, autoplayInterval);
    return function () {
      window.clearInterval(interval);
    };
  }, [autoplay, dragging, axisDistance]);

  if (count === 0) {
    (0, _devLog.devWarning)('Swiper', '`Swiper` needs at least one child.');
  }

  return /*#__PURE__*/_react().default.createElement("div", {
    ref: setRoot,
    className: (0, _classnames().default)(props.className, bem({
      vertical: isVertical
    })),
    style: computedStyle
  }, /*#__PURE__*/_react().default.createElement("div", (0, _extends2().default)({
    ref: trackRef,
    className: (0, _classnames().default)(bem('track', {
      'allow-touch-move': props.allowTouchMove
    })),
    onClickCapture: onClickCapture
  }, props.allowTouchMove ? bind() : {}), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('track-inner', {
      vertical: isVertical
    }))
  }, _react().default.Children.map(validChildren, function (child, index) {
    var _ref3;

    return /*#__PURE__*/_react().default.createElement(_web().animated.div, {
      className: (0, _classnames().default)(bem('slide')),
      style: (_ref3 = {}, (0, _defineProperty2().default)(_ref3, axis, position.to(function (pos) {
        var finalPosition = -pos + index * 100;
        var totalWidth = count * 100;
        var flagWidth = totalWidth / 2;
        finalPosition = modulus(finalPosition + flagWidth, totalWidth) - flagWidth;
        return "".concat(finalPosition, "%");
      })), (0, _defineProperty2().default)(_ref3, "left", "-".concat(index * 100, "%")), _ref3)
    }, child);
  }))), renderIndicator());
});
Swiper.defaultProps = {
  autoplay: false,
  autoplayInterval: 3000,
  allowTouchMove: true,
  defaultIndex: 0,
  loop: true,
  slideSize: 100,
  stuckAtBoundary: false,
  trackOffset: 0
};
Swiper.displayName = 'Swiper';
var _default = Swiper;
exports.default = _default;